Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/FlushExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/FlushExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/FlushExpressions.cs	(revision 14602)
@@ -1,95 +1,93 @@
 ﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-  using HeuristicLab.Algorithms.PushGP.Interpreter;
-  using HeuristicLab.Algorithms.PushGP.Stack;
+    using Interpreter;
+    using Stack;
 
-  /// <summary>
-  ///     Empties the given stack.
-  /// </summary>
-  /// <typeparam name="T">Stacktype</typeparam>
-  public abstract class FlushExpression<T> : StatelessExpression
-  {
-    public void Eval(IStack<T> stack)
+    /// <summary>
+    ///     Empties the given stack.
+    /// </summary>
+    /// <typeparam name="T">Stacktype</typeparam>
+    public abstract class FlushExpression<T> : StatelessExpression
     {
-      stack.Clear();
-    }
-  }
+        protected FlushExpression(string stringRepresentation) : base(stringRepresentation)
+        {
+        }
 
-  public class IntegerFlushExpression : FlushExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.FLUSH";
+        public void Eval(IStack<T> stack)
+        {
+            stack.Clear();
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class IntegerFlushExpression : FlushExpression<long>
     {
-      this.Eval(interpreter.IntegerStack);
-    }
-  }
+        public IntegerFlushExpression() : base("INTEGER.FLUSH")
+        {
+        }
 
-  public class FloatFlushExpression : FlushExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.FLUSH";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class FloatFlushExpression : FlushExpression<double>
     {
-      this.Eval(interpreter.FloatStack);
-    }
-  }
+        public FloatFlushExpression() : base("FLOAT.FLUSH")
+        {
+        }
 
-  public class BooleanFlushExpression : FlushExpression<bool>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "BOOLEAN.FLUSH";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.FloatStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class BooleanFlushExpression : FlushExpression<bool>
     {
-      this.Eval(interpreter.BooleanStack);
-    }
-  }
+        public BooleanFlushExpression() : base("BOOLEAN.FLUSH")
+        {
+        }
 
-  public class NameFlushExpression : FlushExpression<string>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "NAME.FLUSH";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.BooleanStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class NameFlushExpression : FlushExpression<string>
     {
-      this.Eval(interpreter.NameStack);
-    }
-  }
+        public NameFlushExpression() : base("NAME.FLUSH")
+        {
+        }
 
-  public class ExecFlushExpression : FlushExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "EXEC.FLUSH";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.NameStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class ExecFlushExpression : FlushExpression<Expression>
     {
-      this.Eval(interpreter.ExecStack);
-    }
-  }
+        public ExecFlushExpression() : base("EXEC.FLUSH")
+        {
+        }
 
-  public class CodeFlushExpression : FlushExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "CODE.FLUSH";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.ExecStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class CodeFlushExpression : FlushExpression<Expression>
     {
-      this.Eval(interpreter.CodeStack);
+        public CodeFlushExpression() : base("CODE.FLUSH")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.CodeStack);
+        }
     }
-  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/IntegerExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/IntegerExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/IntegerExpressions.cs	(revision 14602)
@@ -1,197 +1,185 @@
 ﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-  using System;
+    using System;
+    using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-  using HeuristicLab.Algorithms.PushGP.Interpreter;
+    /// <summary>
+    ///     Pushes the sum of the top two items.
+    /// </summary>
+    public class IntegerAddExpression : PushResultExpression<long>
+    {
+        public IntegerAddExpression() : base("INTEGER.+")
+        {
+        }
 
-  /// <summary>
-  ///     Pushes the sum of the top two items.
-  /// </summary>
-  public class IntegerAddExpression : PushResultExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.+";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.IntegerStack, 2, values => values[0] + values[1]);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    /// <summary>
+    ///     Pushes the difference of the top two items; that is, the second item minus the top item.
+    /// </summary>
+    public class IntegerSubtractExpression : PushResultExpression<long>
     {
-      this.Eval(interpreter.IntegerStack, 2, values => values[0] + values[1]);
-    }
-  }
+        public IntegerSubtractExpression() : base("INTEGER.-")
+        {
+        }
 
-  /// <summary>
-  ///     Pushes the difference of the top two items; that is, the second item minus the top item.
-  /// </summary>
-  public class IntegerSubtractExpression : PushResultExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.-";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.IntegerStack, 2, values => values[0] - values[1]);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    /// <summary>
+    ///     Pushes the product of the top two items.
+    /// </summary>
+    public class IntegerMultiplyExpression : PushResultExpression<long>
     {
-      this.Eval(interpreter.IntegerStack, 2, values => values[0] - values[1]);
-    }
-  }
+        public IntegerMultiplyExpression() : base("INTEGER.*")
+        {
+        }
 
-  /// <summary>
-  ///     Pushes the product of the top two items.
-  /// </summary>
-  public class IntegerMultiplyExpression : PushResultExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.*";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.IntegerStack, 2, values => values[0] * values[1]);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    /// <summary>
+    ///     Pushes the quotient of the top two items; that is, the second item divided by the top item.
+    ///     If the top item is zero this acts as a NOOP.
+    /// </summary>
+    public class IntegerDivideExpression : PushResultExpression<long>
     {
-      this.Eval(interpreter.IntegerStack, 2, values => values[0] * values[1]);
-    }
-  }
+        public IntegerDivideExpression() : base("INTEGER./")
+        {
+        }
 
-  /// <summary>
-  ///     Pushes the quotient of the top two items; that is, the second item divided by the top item.
-  ///     If the top item is zero this acts as a NOOP.
-  /// </summary>
-  public class IntegerDivideExpression : PushResultExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER./";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.IntegerStack, 2, values => values[0] / values[1], 0);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    /// <summary>
+    ///     Pushes the second stack item modulo the top stack item. If the top item is zero this acts as a NOOP. The modulus is
+    ///     computed as the
+    ///     remainder of the quotient, where the quotient has first been truncated toward negative infinity. (This is taken
+    ///     from the definition
+    ///     for the generic MOD function in Common Lisp, which is described for example at
+    ///     http://www.lispworks.com/reference/HyperSpec/Body/f_mod_r.htm.)
+    /// </summary>
+    public class IntegerModuloExpression : PushResultExpression<long>
     {
-      this.Eval(interpreter.IntegerStack, 2, values => values[0] / values[1], 0);
-    }
-  }
+        public IntegerModuloExpression() : base("INTEGER.%")
+        {
+        }
 
-  /// <summary>
-  ///     Pushes the second stack item modulo the top stack item. If the top item is zero this acts as a NOOP. The modulus is
-  ///     computed as the
-  ///     remainder of the quotient, where the quotient has first been truncated toward negative infinity. (This is taken
-  ///     from the definition
-  ///     for the generic MOD function in Common Lisp, which is described for example at
-  ///     http://www.lispworks.com/reference/HyperSpec/Body/f_mod_r.htm.)
-  /// </summary>
-  public class IntegerModuloExpression : PushResultExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.%";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.IntegerStack, 2, values => values[0] % values[1], 0);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    /// <summary>
+    ///     Pushes the minimum of the top two items.
+    /// </summary>
+    public class IntegerMinExpression : PushResultExpression<long>
     {
-      this.Eval(interpreter.IntegerStack, 2, values => values[0] % values[1], 0);
-    }
-  }
+        public IntegerMinExpression() : base("INTEGER.MIN")
+        {
+        }
 
-  /// <summary>
-  ///     Pushes the minimum of the top two items.
-  /// </summary>
-  public class IntegerMinExpression : PushResultExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.MIN";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.IntegerStack, 2, values => Math.Min(values[0], values[1]));
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    /// <summary>
+    ///     Pushes the maximum of the top two items.
+    /// </summary>
+    public class IntegerMaxExpression : PushResultExpression<long>
     {
-      this.Eval(interpreter.IntegerStack, 2, values => Math.Min(values[0], values[1]));
-    }
-  }
+        public IntegerMaxExpression() : base("INTEGER.MAX")
+        {
+        }
 
-  /// <summary>
-  ///     Pushes the maximum of the top two items.
-  /// </summary>
-  public class IntegerMaxExpression : PushResultExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.MAX";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.IntegerStack, 2, values => Math.Max(values[0], values[1]));
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    /// <summary>
+    ///     Pushes TRUE onto the BOOLEAN stack if the second item is less than the top item, or FALSE otherwise.
+    /// </summary>
+    public class IntegerSmallerThanExpression : PushResultExpression<long>
     {
-      this.Eval(interpreter.IntegerStack, 2, values => Math.Max(values[0], values[1]));
-    }
-  }
+        public IntegerSmallerThanExpression() : base("INTEGER.<")
+        {
+        }
 
-  /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the second item is less than the top item, or FALSE otherwise.
-  /// </summary>
-  public class IntegerSmallerThanExpression : PushResultExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.<";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.IntegerStack, interpreter.BooleanStack, 2, values => values[0] < values[1]);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    /// <summary>
+    ///     Pushes TRUE onto the BOOLEAN stack if the second item is greater than the top item, or FALSE otherwise.
+    /// </summary>
+    public class IntegerGreaterThanExpression : PushResultExpression<long>
     {
-      this.Eval(interpreter.IntegerStack, interpreter.BooleanStack, 2, values => values[0] < values[1]);
-    }
-  }
+        public IntegerGreaterThanExpression() : base("INTEGER.>")
+        {
+        }
 
-  /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the second item is greater than the top item, or FALSE otherwise.
-  /// </summary>
-  public class IntegerGreaterThanExpression : PushResultExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.>";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.IntegerStack, interpreter.BooleanStack, 2, values => values[0] > values[1]);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    /// <summary>
+    ///     Pushes 1 if the top BOOLEAN is TRUE, or 0 if the top BOOLEAN is FALSE.
+    /// </summary>
+    public class IntegerFromBooleanExpression : StatelessExpression
     {
-      this.Eval(interpreter.IntegerStack, interpreter.BooleanStack, 2, values => values[0] > values[1]);
-    }
-  }
+        public IntegerFromBooleanExpression() : base("INTEGER.FROMBOOLEAN")
+        {
+        }
 
-  /// <summary>
-  ///     Pushes 1 if the top BOOLEAN is TRUE, or 0 if the top BOOLEAN is FALSE.
-  /// </summary>
-  public class IntegerFromBooleanExpression : StatelessExpression
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.FROMBOOLEAN";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            if (interpreter.BooleanStack.Count == 0) return;
+
+            var condition = interpreter.BooleanStack.Pop();
+            var value = condition ? 1 : 0;
+
+            interpreter.IntegerStack.Push(value);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    /// <summary>
+    ///     Pushes the result of truncating the top FLOAT.
+    /// </summary>
+    public class IntegerFromFloatExpression : StatelessExpression
     {
-      if (interpreter.BooleanStack.Count == 0) return;
+        public IntegerFromFloatExpression() : base("INTEGER.FROMFLOAT")
+        {
+        }
 
-      var condition = interpreter.BooleanStack.Pop();
-      var value = condition ? 1 : 0;
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            if (interpreter.FloatStack.Count == 0) return;
 
-      interpreter.IntegerStack.Push(value);
+            var value = (int) interpreter.FloatStack.Pop();
+
+            interpreter.IntegerStack.Push(value);
+        }
     }
-  }
-
-  /// <summary>
-  ///     Pushes the result of truncating the top FLOAT.
-  /// </summary>
-  public class IntegerFromFloatExpression : StatelessExpression
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.FROMFLOAT";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      if (interpreter.FloatStack.Count == 0) return;
-
-      var value = (int)interpreter.FloatStack.Pop();
-
-      interpreter.IntegerStack.Push(value);
-    }
-  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/LoopExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/LoopExpression.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/LoopExpression.cs	(revision 14602)
@@ -1,3 +1,4 @@
 ﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
+
   using HeuristicLab.Algorithms.PushGP.Interpreter;
   using HeuristicLab.Algorithms.PushGP.Stack;
@@ -11,5 +12,5 @@
 
   public abstract class LoopExpression : StatefullExpression<LoopState> {
-    protected LoopExpression() : base(new LoopState()) { }
+    protected LoopExpression(string stringRepresentation) : base(new LoopState(), stringRepresentation) { }
 
     protected void Eval(IPushGpInterpreter interpreter, IStack<Expression> sourceStack, bool pushCurrentIndex = false) {
@@ -52,37 +53,36 @@
 
     public override bool Equals(object obj) {
-      if (!base.Equals(obj)) return false;
+      if (this == obj)
+        return true;
+
+      if (obj == null || obj.GetType() != this.GetType())
+        return false;
 
       var other = obj as LoopExpression;
 
-      var isBodyEqual = ((this.State.Body == null) && (other.State.Body == null))
-                        || (this.State.Body != null && this.State.Body.Equals(other.State.Body));
+      if (this.State.CurrentIndex != other.State.CurrentIndex ||
+          this.State.DestinationIndex != other.State.DestinationIndex ||
+          this.State.Incrementor != other.State.Incrementor)
+        return false;
 
-      return isBodyEqual && (this.State.CurrentIndex == other.State.CurrentIndex)
-             && (this.State.DestinationIndex == other.State.DestinationIndex) && (this.State.Incrementor == other.State.Incrementor);
+      var isBodyEqual = this.State.Body == other.State.Body ||
+                        (this.State.Body != null &&
+                        other.State.Body != null &&
+                        this.State.Body.Equals(other.State.Body));
+
+      return isBodyEqual;
     }
 
-    public override string ToString() {
-      return this.StringRepresentation;
-    }
+    protected override int CalcHashCode() {
+      var hash = 19;
 
-    public override int GetHashCode() {
-      return base.GetHashCode();
-    }
+      if (this.State.Body != null)
+        hash = hash * 31 + this.State.Body.GetHashCode();
 
-    protected override int InitId() {
-      unchecked {
-        var hash = 19;
+      hash = hash * 31 + this.State.CurrentIndex.GetHashCode();
+      hash = hash * 31 + this.State.DestinationIndex.GetHashCode();
+      hash = hash * 31 + this.State.Incrementor.GetHashCode();
 
-        hash = hash * 31 + this.GetType().GetHashCode();
-
-        if ((this.State.Body != null) && (this.State.Body != this)) hash = hash * 31 + this.State.Body.GetHashCode();
-
-        hash = hash * 31 + this.State.CurrentIndex.GetHashCode();
-        hash = hash * 31 + this.State.DestinationIndex.GetHashCode();
-        hash = hash * 31 + this.State.Incrementor.GetHashCode();
-
-        return hash;
-      }
+      return hash;
     }
 
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/NameExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/NameExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/NameExpressions.cs	(revision 14602)
@@ -1,85 +1,69 @@
-﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
-  using System.Linq;
-  using System.Threading;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
+{
+    using System.Linq;
+    using System.Threading;
+    using Data.Random;
+    using Interpreter;
+    using Core;
 
-  using HeuristicLab.Algorithms.PushGP.Data.Random;
-  using HeuristicLab.Algorithms.PushGP.Interpreter;
-  using HeuristicLab.Core;
+    public class NameDefineXExecExpression : WrapperExpression<string>
+    {
+        public NameDefineXExecExpression(string state) : base(state) { }
 
-  public class NameDefineXExecExpression : StatefullExpression<string> {
-
-    public NameDefineXExecExpression(string state) : base(state) { }
-
-    public override void Eval(IPushGpInterpreter interpreter) {
-      Expression expression;
-      if (!interpreter.IsNameQuoteFlagSet && interpreter.CustomExpressions.TryGetValue(this.State, out expression)) {
-        interpreter.ExecStack.Push(expression);
-      } else {
-        interpreter.NameStack.Push(this.State);
-        interpreter.IsNameQuoteFlagSet = false;
-      }
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Expression expression;
+            if (!interpreter.IsNameQuoteFlagSet &&
+                interpreter.CustomExpressions.TryGetValue(State, out expression))
+            {
+                interpreter.ExecStack.Push(expression);
+            }
+            else
+            {
+                interpreter.NameStack.Push(State);
+                interpreter.IsNameQuoteFlagSet = false;
+            }
+        }
     }
 
-    public override bool Equals(object obj) {
-      if (!base.Equals(obj)) return false;
+    /// <summary>
+    ///     Sets a flag indicating that the next State encountered will be pushed onto the NAME stack (and not have its
+    ///     associated value
+    ///     pushed onto the EXEC stack), regardless of whether or not it has a definition. Upon encountering such a State and
+    ///     pushing it
+    ///     onto the NAME stack the flag will be cleared (whether or not the pushed State had a definition).
+    /// </summary>
+    public class NameQuoteExpression : StatelessExpression
+    {
+        public NameQuoteExpression() : base("NAME.QUOTE")
+        {
+        }
 
-      var other = obj as NameDefineXExecExpression;
-
-      return this.State.Equals(other.State);
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            interpreter.IsNameQuoteFlagSet = true;
+        }
     }
 
-    public override int GetHashCode() {
-      return base.GetHashCode();
+    /// <summary>
+    ///     Pushes a randomly selected NAME that already has a definition.
+    /// </summary>
+    public class NameRandBoundNameExpression : StatelessExpression
+    {
+        private static readonly ThreadLocal<IRandom> Rand = RandomFactory.GetRandom();
+
+        public NameRandBoundNameExpression() : base("NAME.RANDBOUNDNAME")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            if (!interpreter.CustomExpressions.Any()) return;
+
+            var index = Rand.Value.Next(0, interpreter.CustomExpressions.Keys.Count - 1);
+            var state = interpreter.CustomExpressions.Keys.ElementAt(index);
+
+            interpreter.NameStack.Push(state);
+        }
     }
-
-    protected override string InitStringRepresentation() {
-      return this.State;
-    }
-
-    protected override int InitId() {
-      var hash = 19;
-
-      hash = hash * 31 + this.GetType().GetHashCode();
-      hash = hash * 31 + this.State.GetHashCode();
-
-      return hash;
-    }
-  }
-
-  /// <summary>
-  ///     Sets a flag indicating that the next State encountered will be pushed onto the NAME stack (and not have its
-  ///     associated value
-  ///     pushed onto the EXEC stack), regardless of whether or not it has a definition. Upon encountering such a State and
-  ///     pushing it
-  ///     onto the NAME stack the flag will be cleared (whether or not the pushed State had a definition).
-  /// </summary>
-  public class NameQuoteExpression : StatelessExpression {
-    protected override string InitStringRepresentation() {
-      return "NAME.QUOTE";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter) {
-      interpreter.IsNameQuoteFlagSet = true;
-    }
-  }
-
-  /// <summary>
-  ///     Pushes a randomly selected NAME that already has a definition.
-  /// </summary>
-  public class NameRandBoundNameExpression : StatelessExpression {
-    private static readonly ThreadLocal<IRandom> Rand = RandomFactory.GetRandom();
-
-    protected override string InitStringRepresentation() {
-      return "NAME.RANDBOUNDNAME";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter) {
-      if (!interpreter.CustomExpressions.Any()) return;
-
-      var index = Rand.Value.Next(0, interpreter.CustomExpressions.Keys.Count - 1);
-      var state = interpreter.CustomExpressions.Keys.ElementAt(index);
-
-      interpreter.NameStack.Push(state);
-    }
-  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PopExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PopExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PopExpressions.cs	(revision 14602)
@@ -1,93 +1,91 @@
 ﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-  using HeuristicLab.Algorithms.PushGP.Interpreter;
-  using HeuristicLab.Algorithms.PushGP.Stack;
+    using Interpreter;
+    using Stack;
 
-  public abstract class PopExpression<T> : StatelessExpression
-  {
-    public void Eval(IStack<T> stack)
+    public abstract class PopExpression<T> : StatelessExpression
     {
-      if (stack.Count == 0) return;
+        protected PopExpression(string stringRepresentation) : base(stringRepresentation)
+        {
+        }
 
-      stack.Pop();
-    }
-  }
+        public void Eval(IStack<T> stack)
+        {
+            if (stack.Count == 0) return;
 
-  public class IntegerPopExpression : PopExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.POP";
+            stack.Pop();
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class IntegerPopExpression : PopExpression<long>
     {
-      this.Eval(interpreter.IntegerStack);
-    }
-  }
+        public IntegerPopExpression() : base("INTEGER.POP")
+        {
+        }
 
-  public class FloatPopExpression : PopExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.POP";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class FloatPopExpression : PopExpression<double>
     {
-      this.Eval(interpreter.FloatStack);
-    }
-  }
+        public FloatPopExpression() : base("FLOAT.POP")
+        {
+        }
 
-  public class BooleanPopExpression : PopExpression<bool>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "BOOLEAN.POP";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.FloatStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class BooleanPopExpression : PopExpression<bool>
     {
-      this.Eval(interpreter.BooleanStack);
-    }
-  }
+        public BooleanPopExpression() : base("BOOLEAN.POP")
+        {
+        }
 
-  public class NamePopExpression : PopExpression<string>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "NAME.POP";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.BooleanStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class NamePopExpression : PopExpression<string>
     {
-      this.Eval(interpreter.NameStack);
-    }
-  }
+        public NamePopExpression() : base("NAME.POP")
+        {
+        }
 
-  public class ExecPopExpression : PopExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "EXEC.POP";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.NameStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class ExecPopExpression : PopExpression<Expression>
     {
-      this.Eval(interpreter.ExecStack);
-    }
-  }
+        public ExecPopExpression() : base("EXEC.POP")
+        {
+        }
 
-  public class CodePopExpression : PopExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "CODE.POP";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.ExecStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class CodePopExpression : PopExpression<Expression>
     {
-      this.Eval(interpreter.CodeStack);
+        public CodePopExpression() : base("CODE.POP")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.CodeStack);
+        }
     }
-  }
 }
